'ﾊﾞﾝﾄﾞﾏﾄﾘｯｸｽのｿﾙﾊﾞｰ(ﾊｰﾌﾊﾞﾝﾄﾞ)V17の標準ﾓｼﾞｭｰﾙ   ［作成］黒田英夫(2023/04)
'ﾊﾞﾝﾄﾞﾏﾄﾘｯｸｽは対角に関して対称で、右上側のみで解く。
Imports System.Drawing.Printing

Module SolvHCom

    'V6での改良点・・・VB2010版に変換
    'V7での改良点・・・ｻﾌﾞﾙｰﾁﾝSolverHalfをﾓｼﾞｭｰﾙ化
    'V8での改良点・・・汎用化に全面変更
    'V9での改良点・・・入力データファイル読み込みのエラー処理追加
    'V10での改良点・・・.NetFrameworkの指定バージョンを3.5から4に変更
    'V11での改良点・・・入力データファイルの先頭にプログラム名を追加
    '                   （データの読み違いを防止）
    'V12での改良点・・・実行形式をDebugモードからReleaseモードへ変更
    '                   （計算時間の大幅短縮）
    'V13での改良点・・・各画面でボタンを読みやすい色に改善
    'V14での改良点・・・Visual Basic 2017に変更
    'V15での改良点・・・プログラムファイルの文字コードをUTF-8に統一、
    '                   データファイルの文字コードをUTF-8に変更
    'V16での改良点・・・入力データのファイル印刷メニューを廃止
    '                   （文字コードによる不具合のため）
    'V17での改良点・・・フリーソフト化、VB2022に移行

    Public CalcRes$             '計算結果表示データ
    Public DirOpen$             '立ち上げ時のディレクトリー名
    Public Fm$                  '入力データのファイル名
    Public Fy$                  '計算結果のファイル名
    Public Title$               'タイトル

    Public Timst As Date        '計算開始時刻

    Public InOut As Integer     'ファイル入出力の種類（0:入力、1:出力）
    Public KdataBackup As Integer   '入力データのバックアップファイル作成（0:なし、1:有り）
    Public KdataChange As Integer   'データ変更の有無（0:なし、1:有り）
    Public Kindex As Integer    'ﾃｷｽﾄｱﾚｲのｲﾝﾃﾞｯｸｽ
    Public KnewUFileA As Integer    '最近使用ﾌｧｲﾙAの更新有無
    Public Mhalf As Integer     '半分のﾊﾞﾝﾄﾞ幅（＝(全ﾊﾞﾝﾄﾞ幅－1)／2＋1 ）
    Public N As Integer         '変数の数（＝方程式の数）
    Public Nline As Integer     'ﾌｧｲﾙの行数

    Public ArrText As New ArrayList()

    Public UFileA(6) As String  '最近使用した入力ﾌｧｲﾙの保存配列

    Public Tf() As Single       '右辺ﾍﾞｸﾄﾙ、後で変数解が入る
    Public Tk(,) As Single      'ﾊﾞﾝﾄﾞﾏﾄﾘｯｸｽ（行数Ｎ、列数はﾊｰﾌﾊﾞﾝﾄﾞ幅）

    Sub DfileInputU(ByVal fxx$)
        '入力ﾃﾞｰﾀﾌｧｲﾙの読み込み
        'UTF-8･･･BOMなし
        'fxx$･･･入力ﾌｧｲﾙ名
        'ii･･･ﾌｧｲﾙ番号
        Dim aa$
        Dim i, j As Integer

        Dim sr As New System.IO.StreamReader(fxx$)
        Dim dat() As String

        aa$ = sr.ReadLine
        dat = aa.Split(",")
        aa$ = dat(1)
        If aa$ <> "BMSolverH" Then
            aa$ = "データファイルが違います！"
            MsgBox(aa$, 0, "データエラー")
            sr.Close()
            Exit Sub
        End If
        Title$ = sr.ReadLine
        aa$ = sr.ReadLine
        dat = aa.Split(",")
        N = dat(1)
        aa$ = sr.ReadLine
        dat = aa.Split(",")
        Mhalf = dat(1)
        ReDim Tk(N, Mhalf), Tf(N)

        aa$ = sr.ReadLine
        aa$ = sr.ReadLine
        For i = 1 To N
            aa$ = sr.ReadLine
            dat = aa.Split(",")
            For j = 1 To Mhalf
                Tk(i, j) = dat(j)
            Next j
            Tf(i) = dat(Mhalf + 1)
        Next i
        sr.Close()

    End Sub

    Sub DfileOutU(ByVal fxx$)
        '入力ﾃﾞｰﾀﾌｧｲﾙへの書き出し
        'UTF-8･･･BOMなし
        'fxx$･･･入力ﾃﾞｰﾀﾌｧｲﾙ名
        Dim aa$
        Dim i, j As Integer

        Dim sw As New IO.StreamWriter(fxx$)
        aa$ = "プログラム名" + "," + "BMSolverH"
        sw.WriteLine(aa$)
        sw.WriteLine(Title$)
        aa$ = "変数の数" + "," + Str(N)
        sw.WriteLine(aa$)
        aa$ = "ハーフバンド幅" + "," + Str(Mhalf)
        sw.WriteLine(aa$)

        sw.WriteLine("＜方程式データ＞")
        sw.WriteLine("行番号、ハーフバンドの各係数、右辺")
        For i = 1 To N
            aa$ = Str$(i)
            For j = 1 To Mhalf
                aa$ = aa$ + ",  " + Str(Tk(i, j))
            Next j
            aa$ = aa$ + ",   " + Str(Tf(i))
            sw.WriteLine(aa$)
        Next i
        sw.Close()
        aa$ = "データをファイルへ保存しました。"
        MsgBox(aa$, 0, "ファイル保存完了")

    End Sub

    Sub FileName(ByRef fxx$, ByRef fxb$)
        'ﾌｧｲﾙ名fxx$の拡張子なしの部分fxb$を取り出す
        Dim i As Integer
        i = InStr(fxx$, ".")
        If i > 0 Then
            fxb$ = Left$(fxx$, i - 1)
        Else
            fxb$ = fxx$
        End If
    End Sub

    Sub OptFileIn()
        'ｵﾌﾟｼｮﾝ･ﾌｧｲﾙ読み込み
        'UTF-8･･･BOMなし
        Dim ftmp$

        ftmp$ = DirOpen$ + "\BMSolHMenu.tmp"
        Try
            Dim sr As New IO.StreamReader(ftmp$)
            KdataBackup = Val(sr.ReadLine)
            sr.Close()
        Catch
            '処理不要
        End Try

    End Sub

    Sub OptFileOut()
        'ｵﾌﾟｼｮﾝ･ﾌｧｲﾙ書き出し
        'UTF-8･･･BOMなし
        Dim ftmp$

        ftmp$ = DirOpen$ + "\BMSolHMenu.tmp"
        Dim sw As New IO.StreamWriter(ftmp$)
        sw.WriteLine(KdataBackup)
        sw.Close()

    End Sub

    Sub PDoc_PrintPage(ByVal sender As System.Object, ByVal e As System.Drawing.Printing.PrintPageEventArgs)
        Dim linesPerPage As Integer
        Dim ypos As Single
        Dim ic, ncount As Integer
        Dim xleftMargin As Single
        Dim ytopMargin As Single
        Dim lineText$
        Dim printfont As Font = New Font("ＭＳ ゴシック", 10)

        linesPerPage = e.MarginBounds.Height / printfont.GetHeight(e.Graphics)
        ypos = 0
        ncount = 0
        xleftMargin = e.MarginBounds.Left
        ytopMargin = e.MarginBounds.Top

        ic = 0
        While ncount < linesPerPage
            If Kindex < Nline Then
                lineText$ = ArrText(Kindex)
                Kindex = Kindex + 1
            Else
                ic = 1
                Exit While
            End If
            ypos = ytopMargin + ncount * printfont.GetHeight(e.Graphics)
            e.Graphics.DrawString(lineText$, printfont, Brushes.Black, xleftMargin, ypos, New StringFormat())
            ncount = ncount + 1
        End While

        If ic = 0 And Kindex < Nline Then
            e.HasMorePages = True
        Else
            e.HasMorePages = False
        End If

    End Sub

    Sub SolverHalf(ByRef kh As Integer, ByVal mh As Integer, ByVal nx As Integer, _
    ByRef fmat(,) As Double, ByRef cvec() As Double)
        'ﾊｰﾌﾊﾞﾝﾄﾞ･ﾏﾄﾘｯｸｽのｿﾙﾊﾞｰ
        'kh･･･ｴﾗｰ有無（0:なし、-1:有り）
        'mh･･･ハーフバンド幅
        'nx･･･変数の数
        'fmat(,)･･･ハーフバンドの係数行列
        'cvec()･･･右辺および解
        Dim aa$
        Dim i, it, j, jt, k, mx As Integer
        Dim pivotvalue, s, valuex As Double
        Dim ua(mh) As Double        '計算途中の保存配列

        kh = 0
        '前進方向の計算
        For k = 1 To nx - 1
            mx = mh
            If k + mh - 1 > nx Then   'ﾏﾄﾘｯｸｽの不在列ﾁｪｯｸ
                mx = nx - k + 1
            End If
            pivotvalue = fmat(k, 1)
            If pivotvalue = 0 Then
                'ｴﾗｰ処理
                kh = -1
                aa$ = "pivotvalue=0 AT k=" + Str$(k)
                aa$ = aa$ + Chr(13) + Chr(10) + "計算を終了させます！"
                MsgBox(aa$, 0, "計算エラー")
                Exit Sub
            Else
                For j = 2 To mx
                    ua(j) = fmat(k, j) / pivotvalue
                Next j
            End If

            cvec(k) = cvec(k) / pivotvalue
            For i = 2 To mx
                it = i + k - 1
                valuex = fmat(k, i)
                If valuex <> 0 Then
                    For j = i To mx
                        jt = j - i + 1
                        fmat(it, jt) = fmat(it, jt) - valuex * ua(j)
                    Next j
                    cvec(it) = cvec(it) - valuex * cvec(k)
                End If
            Next i
        Next k

        '最終変数の解
        cvec(nx) = cvec(nx) / fmat(nx, 1)

        '後退方向の計算
        For k = nx - 1 To 1 Step -1
            s = 0
            mx = mh
            If k + mh - 1 > nx Then
                mx = nx - k + 1
            End If
            For j = 2 To mx
                jt = j + k - 1
                s = s + fmat(k, j) * cvec(jt)
            Next j
            cvec(k) = cvec(k) - s / fmat(k, 1)
        Next k

    End Sub

    Sub TimCal(ByVal ktim As Integer, ByRef timn$)
        'ﾀｲﾏｰ計算
        'ktim･･･時間継続指定（0:時間ｸﾘｱする、1:時間継続する）
        'timn$･･･時分秒に換算した経過時間
        Dim rtime As Date = Now
        Dim rhour, rmin, sec As Single
        If ktim > 0 Then
            sec = DateDiff(DateInterval.Second, Timst, rtime)
            rhour = Int(sec / 3600) : sec = sec - rhour * 3600
            rmin = Int(sec / 60) : sec = Int(sec - rmin * 60)
            timn$ = Str$(rhour) + "h" + Str$(rmin) + "min" + Str$(sec) + "s"
        Else
            Timst = rtime
        End If
    End Sub

    Sub TmpFileIn()
        'ﾃﾝﾎﾟﾗﾘｰ･ﾌｧｲﾙ読み込み
        'UTF-8･･･BOMなし
        Dim ftmp$

        ftmp$ = DirOpen$ + "\BMSolverH.tmp"
        Try
            Dim sr As New IO.StreamReader(ftmp$)
            Fm$ = sr.ReadLine
            Fy$ = sr.ReadLine
            sr.Close()
        Catch
            '処理不要
        End Try

    End Sub

    Sub TmpFileOut()
        'ﾃﾝﾎﾟﾗﾘｰ･ﾌｧｲﾙ書き出し
        'UTF-8･･･BOMなし
        Dim ftmp$

        ftmp$ = DirOpen$ + "\BMSolverH.tmp"
        Dim sw As New IO.StreamWriter(ftmp$)
        sw.WriteLine(Fm$)
        sw.WriteLine(Fy$)
        sw.Close()

    End Sub

    Sub UFileAddA()
        'UFileAの追加処理
        Dim i, ic, j As Integer
        ic = 0
        For i = 2 To 6
            If UFileA(i) = UFileA(0) Then
                For j = i - 1 To 0 Step -1
                    UFileA(j + 1) = UFileA(j)
                Next j
                ic = 1
                Exit For
            End If
        Next i
        If ic = 0 Then
            For i = 5 To 0 Step -1
                UFileA(i + 1) = UFileA(i)
            Next i
        End If
        UseFileAOut()       'ﾃﾝﾎﾟﾗﾘｰ･ﾌｧｲﾙ書き出し

    End Sub

    Sub UseFileAIn()
        'ﾃﾝﾎﾟﾗﾘｰ･ﾌｧｲﾙ読み込み
        'UTF-8･･･BOMなし
        Dim ftmp$
        Dim i As Integer

        ftmp$ = DirOpen$ + "\BMSolHfileA.tmp"
        Try
            Dim sr As New IO.StreamReader(ftmp$)
            i = 0
            Do Until sr.Peek = -1 'ﾌｧｲﾙ末尾まで
                i = i + 1
                UFileA(i) = sr.ReadLine
            Loop
            sr.Close()
        Catch
            '処理不要
        End Try

    End Sub

    Sub UseFileAOut()
        'ﾃﾝﾎﾟﾗﾘｰ･ﾌｧｲﾙ書き出し
        'UTF-8･･･BOMなし
        Dim ftmp$
        Dim i As Integer

        ftmp$ = DirOpen$ + "\BMSolHfileA.tmp"
        Dim sw As New IO.StreamWriter(ftmp$)
        For i = 1 To 6
            If UFileA(i) <> "" Then
                sw.WriteLine(UFileA(i))
            Else
                Exit For
            End If
        Next i
        sw.Close()

    End Sub

End Module
